3 . git-sh-setup || die "Not a git archive"
5 _x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
6 _x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
12 while case "$#" in 0) break ;; esac
15 -a|--a|--ap|--app|--appe|--appen|--append)
18 -f|--f|--fo|--for|--forc|--force)
21 -t|--t|--ta|--tag|--tags)
24 -u|--u|--up|--upd|--upda|--updat|--update|--update-|--update-h|\
25 --update-he|--update-hea|--update-head|--update-head-|\
26 --update-head-o|--update-head-ok)
38 test -f "$GIT_DIR/branches/origin" ||
39 test -f "$GIT_DIR/remotes/origin" ||
40 die "Where do you want to fetch from today?"
45 remote=$(get_remote_url "$@")
48 rsync_slurped_objects=
50 if test "" = "$append"
52 : >"$GIT_DIR/FETCH_HEAD"
55 append_fetch_head () {
62 t) not_for_merge_='not-for-merge' ;;
63 '') not_for_merge_= ;;
66 # remote-nick is the URL given on the command line (or a shorthand)
67 # remote-name is the $GIT_DIR relative refs/ path we computed
69 case "$remote_name_" in
73 note_="$(expr "$remote_name_" : 'refs/heads/\(.*\)')"
74 note_="branch '$note_' of " ;;
76 note_="$(expr "$remote_name_" : 'refs/tags/\(.*\)')"
77 note_="tag '$note_' of " ;;
79 note_="$remote_name of " ;;
81 remote_1_=$(expr "$remote_" : '\(.*\)\.git/*$') &&
83 note_="$note_$remote_"
85 # 2.6.11-tree tag would not be happy to be fed to resolve.
86 if git-cat-file commit "$head_" >/dev/null 2>&1
88 headc_=$(git-rev-parse --verify "$head_^0") || exit
89 echo "$headc_ $not_for_merge_ $note_" >>"$GIT_DIR/FETCH_HEAD"
90 echo >&2 "* committish: $head_"
93 echo "$head_ not-for-merge $note_" >>"$GIT_DIR/FETCH_HEAD"
94 echo >&2 "* non-commit: $head_"
97 if test "$local_name_" != ""
99 # We are storing the head locally. Make sure that it is
100 # a fast forward (aka "reverse push").
101 fast_forward_local "$local_name_" "$head_" "$note_"
105 fast_forward_local () {
106 mkdir -p "$(dirname "$GIT_DIR/$1")"
109 # Tags need not be pointing at commits so there
110 # is no way to guarantee "fast-forward" anyway.
111 if test -f "$GIT_DIR/$1"
113 echo >&2 "* $1: updating with $3"
115 echo >&2 "* $1: storing $3"
117 git-update-ref "$1" "$2"
121 # $1 is the ref being updated.
122 # $2 is the new value for the ref.
123 local=$(git-rev-parse --verify "$1^0" 2>/dev/null)
126 # Require fast-forward.
127 mb=$(git-merge-base "$local" "$2") &&
130 echo >&2 "* $1: same as $3"
133 echo >&2 "* $1: fast forward to $3"
134 git-update-ref "$1" "$2" "$local"
140 echo >&2 "* $1: does not fast forward to $3;"
141 case ",$force,$single_force," in
143 echo >&2 " forcing update."
144 git-update-ref "$1" "$2" "$local"
147 echo >&2 " not updating."
152 echo >&2 "* $1: storing $3"
153 git-update-ref "$1" "$2"
159 case "$update_head_ok" in
161 orig_head=$(git-rev-parse --verify HEAD 2>/dev/null)
165 # If --tags (and later --heads or --all) is specified, then we are
166 # not talking about defaults stored in Pull: line of remotes or
167 # branches file, and just fetch those and refspecs explicitly given.
168 # Otherwise we do what we always did.
170 reflist=$(get_remote_refs_for_fetch "$@")
173 taglist=$(git-ls-remote --tags "$remote" |
180 # remote URL plus explicit refspecs; we need to merge them.
181 reflist="$reflist $taglist"
183 # No explicit refspecs; fetch tags only.
192 # These are relative path from $GIT_DIR, typically starting at refs/
194 if expr "$ref" : '\.' >/dev/null
197 ref=$(expr "$ref" : '\.\(.*\)')
201 if expr "$ref" : '\+' >/dev/null
204 ref=$(expr "$ref" : '\+\(.*\)')
208 remote_name=$(expr "$ref" : '\([^:]*\):')
209 local_name=$(expr "$ref" : '[^:]*:\(.*\)')
211 rref="$rref $remote_name"
213 # There are transports that can fetch only one head at a time...
215 http://* | https://*)
216 if [ -n "$GIT_SSL_NO_VERIFY" ]; then
219 head=$(curl -nsf $curl_extra_args "$remote/$remote_name") &&
220 expr "$head" : "$_x40\$" >/dev/null ||
221 die "Failed to fetch $remote_name from $remote"
222 echo >&2 Fetching "$remote_name from $remote" using http
223 git-http-fetch -v -a "$head" "$remote/" || exit
226 TMP_HEAD="$GIT_DIR/TMP_HEAD"
227 rsync -L -q "$remote/$remote_name" "$TMP_HEAD" || exit 1
228 head=$(git-rev-parse --verify TMP_HEAD)
230 test "$rsync_slurped_objects" || {
231 rsync -av --ignore-existing --exclude info \
232 "$remote/objects/" "$GIT_OBJECT_DIRECTORY/" || exit
234 # Look at objects/info/alternates for rsync -- http will
235 # support it natively and git native ones will do it on the remote
236 # end. Not having that file is not a crime.
237 rsync -q "$remote/objects/info/alternates" \
238 "$GIT_DIR/TMP_ALT" 2>/dev/null ||
239 rm -f "$GIT_DIR/TMP_ALT"
240 if test -f "$GIT_DIR/TMP_ALT"
242 resolve_alternates "$remote" <"$GIT_DIR/TMP_ALT" |
245 case "$alt" in 'bad alternate: '*) die "$alt";; esac
246 echo >&2 "Getting alternate: $alt"
247 rsync -av --ignore-existing --exclude info \
248 "$alt" "$GIT_OBJECT_DIRECTORY/" || exit
250 rm -f "$GIT_DIR/TMP_ALT"
252 rsync_slurped_objects=t
256 # We will do git native transport with just one call later.
260 append_fetch_head "$head" "$remote" \
261 "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
266 http://* | https://* | rsync://* )
267 ;; # we are already done.
270 git-fetch-pack "$remote" $rref || echo failed "$remote"
272 while read sha1 remote_name
276 echo >&2 "Fetch failure: $remote"
304 local_name=$(expr "$found" : '[^:]*:\(.*\)')
305 append_fetch_head "$sha1" "$remote" \
306 "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
311 # If the original head was empty (i.e. no "master" yet), or
312 # if we were told not to worry, we do not have to check.
313 case ",$update_head_ok,$orig_head," in
317 curr_head=$(git-rev-parse --verify HEAD 2>/dev/null)
318 if test "$curr_head" != "$orig_head"
320 git-update-ref HEAD "$orig_head"
321 die "Cannot fetch into the current branch."